diff --git a/src/main/java/net/minecraft/core/block/ButtonBlock.java b/src/main/java/net/minecraft/core/block/ButtonBlock.java
index c6d345cb4..6d0d00b53 100644
--- a/src/main/java/net/minecraft/core/block/ButtonBlock.java
+++ b/src/main/java/net/minecraft/core/block/ButtonBlock.java
@@ -2,7 +2,6 @@ package net.minecraft.core.block;
 
 import net.minecraft.core.block.entity.ActivatorBlockEntity;
 import net.minecraft.core.block.material.Material;
-import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.Item;
@@ -24,6 +23,14 @@ import java.util.Random;
 
 public class ButtonBlock extends Block
 {
+    public static final int MASK_POWERED = 0b0000_1000;
+    public static final int MASK_DIRECTION = 0b0000_0111;
+    public static final int SIDE_WEST = 1;
+    public static final int SIDE_EAST = 2;
+    public static final int SIDE_NORTH = 3;
+    public static final int SIDE_SOUTH = 4;
+    public static final int SIDE_TOP = 5;
+    public static final int SIDE_BOTTOM = 6;
 
 	public ButtonBlock(String key, String namespaceId, int id)
     {
@@ -86,115 +93,115 @@ public class ButtonBlock extends Block
         }
         return world.isBlockNormalCube(x, y, z + 1);
     }
-    
+
     @Override
-    public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side side, Mob mob, double sideHeight) {
-        int i1 = world.getBlockMetadata(x, y, z);
-        int j1 = i1 & 8;
-        i1 &= 7;
-        if(side == Side.BOTTOM && world.isBlockNormalCube(x, y + 1, z)) {
-            i1 = 5;
-        } else if(side == Side.TOP && world.isBlockNormalCube(x, y - 1, z)) {
-            i1 = 6;
-        } else if(side == Side.NORTH && world.isBlockNormalCube(x, y, z + 1)) {
-            i1 = 4;
-        } else if(side == Side.SOUTH && world.isBlockNormalCube(x, y, z - 1)) {
-            i1 = 3;
-        } else if(side == Side.WEST && world.isBlockNormalCube(x + 1, y, z)) {
-            i1 = 2;
-        } else if(side == Side.EAST && world.isBlockNormalCube(x - 1, y, z)) {
-            i1 = 1;
-        } else {
-            i1 = getOrientation(world, x, y, z);
+    public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+        int orientation = -1;
+        switch (side) {
+            case BOTTOM:
+                if (world.isBlockNormalCube(x, y + 1, z)) {
+                    orientation = SIDE_TOP;
+                }
+                break;
+            case TOP:
+                if (world.isBlockNormalCube(x, y - 1, z)) {
+                    orientation = SIDE_BOTTOM;
+                }
+                break;
+            case NORTH:
+                if (world.isBlockNormalCube(x, y, z + 1)) {
+                    orientation = SIDE_SOUTH;
+                }
+                break;
+            case SOUTH:
+                if (world.isBlockNormalCube(x, y, z - 1)) {
+                    orientation = SIDE_NORTH;
+                }
+                break;
+            case WEST:
+                if (world.isBlockNormalCube(x + 1, y, z)) {
+                    orientation = SIDE_EAST;
+                }
+                break;
+            case EAST:
+                if (world.isBlockNormalCube(x - 1, y, z)) {
+                    orientation = SIDE_EAST;
+                }
+                break;
+        }
+        if (orientation == -1) {
+            orientation = getOrientation(world, x, y, z);
         }
-        world.setBlockMetadataWithNotify(x, y, z, i1 + j1);
+        int meta = world.getBlockMetadata(x, y, z);
+        world.setBlockMetadataWithNotify(x, y, z, (meta & ~MASK_DIRECTION) | orientation);
     }
-    
+
     private int getOrientation(World world, int x, int y, int z)
     {
         if(world.isBlockNormalCube(x - 1, y, z))
         {
-            return 1;
+            return SIDE_WEST;
         }
         if(world.isBlockNormalCube(x + 1, y, z))
         {
-            return 2;
+            return SIDE_EAST;
         }
         if(world.isBlockNormalCube(x, y, z - 1))
         {
-            return 3;
+            return SIDE_NORTH;
         }
         if (world.isBlockNormalCube(x, y, z + 1)){
-            return 4;
+            return SIDE_SOUTH;
         }
         if (world.isBlockNormalCube(x, y + 1, z)){
-            return 5;
+            return SIDE_TOP;
         }
         if (world.isBlockNormalCube(x, y - 1, z)){
-            return 6;
+            return SIDE_BOTTOM;
         }
-        return 1;
+        return SIDE_WEST;
     }
 
     @Override
 	public void onNeighborBlockChange(World world, int x, int y, int z, int blockId)
     {
-        if(canButtonStay(world, x, y, z))
-        {
-            int i1 = world.getBlockMetadata(x, y, z) & 7;
-            boolean flag = false;
-            if(!world.isBlockNormalCube(x - 1, y, z) && i1 == 1)
-            {
-                flag = true;
-            }
-            if(!world.isBlockNormalCube(x + 1, y, z) && i1 == 2)
-            {
-                flag = true;
-            }
-            if(!world.isBlockNormalCube(x, y, z - 1) && i1 == 3)
-            {
-                flag = true;
-            }
-            if(!world.isBlockNormalCube(x, y, z + 1) && i1 == 4)
-            {
-                flag = true;
-            }
-            if(!world.isBlockNormalCube(x, y + 1, z) && i1 == 5)
-            {
-                flag = true;
-            }
-            if(!world.isBlockNormalCube(x, y - 1, z) && i1 == 6)
-            {
-                flag = true;
-            }
-            if(flag)
-            {
-                dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, i1, null, null);
-                world.setBlockWithNotify(x, y, z, 0);
-            }
+        boolean invalid;
+        int side = world.getBlockMetadata(x, y, z) & MASK_DIRECTION;
+        switch (side) {
+            case SIDE_WEST:
+                invalid = !world.isBlockNormalCube(x - 1, y, z);
+                break;
+            case SIDE_EAST:
+                invalid = !world.isBlockNormalCube(x + 1, y, z);
+                break;
+            case SIDE_NORTH:
+                invalid = !world.isBlockNormalCube(x, y, z - 1);
+                break;
+            case SIDE_SOUTH:
+                invalid = !world.isBlockNormalCube(x, y, z + 1);
+                break;
+            case SIDE_TOP:
+                invalid = !world.isBlockNormalCube(x, y + 1, z);
+                break;
+            case SIDE_BOTTOM:
+                invalid = !world.isBlockNormalCube(x, y - 1, z);
+                break;
+            default:
+                invalid = true;
         }
-    }
-
-    private boolean canButtonStay(World world, int x, int y, int z)
-    {
-        if(!canPlaceBlockAt(world, x, y, z))
+        if(invalid)
         {
-            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, world.getBlockMetadata(x, y, z), null, null);
+            dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, side, null, null);
             world.setBlockWithNotify(x, y, z, 0);
-            return false;
-        }
-        else
-        {
-            return true;
         }
     }
 
     @Override
     public void setBlockBoundsBasedOnState(WorldSource world, int x, int y, int z)
     {
-        int l = world.getBlockMetadata(x, y, z);
-        int i1 = l & 7;
-        boolean flag = (l & 8) > 0;
+        int meta = world.getBlockMetadata(x, y, z);
+        int direction = meta & MASK_DIRECTION;
+        boolean flag = (meta & MASK_POWERED) != 0;
         float f = 0.375F;
         float f1 = 0.625F;
         float f2 = 0.1875F;
@@ -203,18 +210,25 @@ public class ButtonBlock extends Block
         {
             f3 = 0.0625F;
         }
-        if(i1 == 1) {
-            setBlockBounds(0.0F, f, 0.5F - f2, f3, f1, 0.5F + f2);
-        } else if(i1 == 2) {
-            setBlockBounds(1.0F - f3, f, 0.5F - f2, 1.0F, f1, 0.5F + f2);
-        } else if(i1 == 3) {
-            setBlockBounds(0.5F - f2, f, 0.0F, 0.5F + f2, f1, f3);
-        } else if(i1 == 4) {
-            setBlockBounds(0.5F - f2, f, 1.0F - f3, 0.5F + f2, f1, 1.0F);
-        } else if(i1 == 5) { // Top
-            setBlockBounds(0.5f - f2, 1 - f3, f, 0.5f + f2, 1.0, f1);
-        } else if(i1 == 6) { // Bottom
-            setBlockBounds(0.5f - f2, 0, f, 0.5f + f2, f3, f1);
+        switch (direction) {
+            case SIDE_WEST:
+                setBlockBounds(0.0F, f, 0.5F - f2, f3, f1, 0.5F + f2);
+                break;
+            case SIDE_EAST:
+                setBlockBounds(1.0F - f3, f, 0.5F - f2, 1.0F, f1, 0.5F + f2);
+                break;
+            case SIDE_NORTH:
+                setBlockBounds(0.5F - f2, f, 0.0F, 0.5F + f2, f1, f3);
+                break;
+            case SIDE_SOUTH:
+                setBlockBounds(0.5F - f2, f, 1.0F - f3, 0.5F + f2, f1, 1.0F);
+                break;
+            case SIDE_TOP:
+                setBlockBounds(0.5f - f2, 1 - f3, f, 0.5f + f2, 1.0, f1);
+                break;
+            case SIDE_BOTTOM:
+                setBlockBounds(0.5f - f2, 0, f, 0.5f + f2, f3, f1);
+                break;
         }
     }
 
@@ -233,29 +247,36 @@ public class ButtonBlock extends Block
     }
 
     public boolean press(World world, int x, int y, int z, @Nullable Player player) {
-        int l = world.getBlockMetadata(x, y, z);
-        int i1 = l & 7;
-        int j1 = 8 - (l & 8);
-        if(j1 == 0)
+        int meta = world.getBlockMetadata(x, y, z);
+        int direction = meta & MASK_DIRECTION;
+        boolean isPowered = (meta & MASK_POWERED) != 0;
+        if(isPowered)
         {
             return true;
         }
-        world.setBlockMetadataWithNotify(x, y, z, i1 + j1);
+        world.setBlockMetadataWithNotify(x, y, z, direction | MASK_POWERED);
         world.markBlocksDirty(x, y, z, x, y, z);
         world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, 0.6F);
         world.notifyBlocksOfNeighborChange(x, y, z, id);
-        if(i1 == 1) {
-            world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-        } else if(i1 == 2) {
-            world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-        } else if(i1 == 3) {
-            world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-        } else if(i1 == 4) {
-            world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-        } else if(i1 == 5) {
-            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
-        } else {
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+        switch (direction) {
+            case SIDE_WEST:
+                world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+                break;
+            case SIDE_EAST:
+                world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+                break;
+            case SIDE_NORTH:
+                world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+                break;
+            case SIDE_SOUTH:
+                world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+                break;
+            case SIDE_TOP:
+                world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+                break;
+            case SIDE_BOTTOM:
+                world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+                break;
         }
         world.scheduleBlockUpdate(x, y, z, id, tickDelay());
         return true;
@@ -269,22 +290,29 @@ public class ButtonBlock extends Block
     @Override
     public void onBlockRemoved(World world, int x, int y, int z, int data)
     {
-        if((data & 8) > 0)
+        if((data & MASK_POWERED) != 0)
         {
             world.notifyBlocksOfNeighborChange(x, y, z, id);
-            int i1 = data & 7;
-            if(i1 == 1) {
-                world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-            } else if(i1 == 2) {
-                world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-            } else if(i1 == 3) {
-                world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-            } else if(i1 == 4) {
-                world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-            } else if(i1 == 5) {
-                world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
-            } else {
-                world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+            int direction = data & MASK_DIRECTION;
+            switch (direction) {
+                case SIDE_WEST:
+                    world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+                    break;
+                case SIDE_EAST:
+                    world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+                    break;
+                case SIDE_NORTH:
+                    world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+                    break;
+                case SIDE_SOUTH:
+                    world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+                    break;
+                case SIDE_TOP:
+                    world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+                    break;
+                case SIDE_BOTTOM:
+                    world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+                    break;
             }
         }
         super.onBlockRemoved(world, x, y, z, data);
@@ -293,33 +321,32 @@ public class ButtonBlock extends Block
     @Override
     public boolean getSignal(WorldSource worldSource, int x, int y, int z, Side side)
     {
-        return (worldSource.getBlockMetadata(x, y, z) & 8) > 0;
+        return (worldSource.getBlockMetadata(x, y, z) & MASK_POWERED) != 0;
     }
 
     @Override
     public boolean getDirectSignal(World world, int x, int y, int z, Side side)
     {
         int meta = world.getBlockMetadata(x, y, z);
-        if((meta & 8) == 0) {
+        if((meta & MASK_POWERED) == 0) {
             return false;
         }
-        int direction = meta & 7;
-        if(direction == 6 && side == Side.TOP) {
-            return true;
-        }
-        if(direction == 5 && side == Side.BOTTOM) {
-            return true;
-        }
-        if(direction == 4 && side == Side.NORTH) {
-            return true;
+        int direction = meta & MASK_DIRECTION;
+        switch (direction) {
+            case SIDE_WEST:
+                return side == Side.EAST;
+            case SIDE_EAST:
+                return side == Side.WEST;
+            case SIDE_NORTH:
+                return side == Side.SOUTH;
+            case SIDE_SOUTH:
+                return side == Side.NORTH;
+            case SIDE_TOP:
+                return side == Side.BOTTOM;
+            case SIDE_BOTTOM:
+                return side == Side.TOP;
         }
-        if(direction == 3 && side == Side.SOUTH) {
-            return true;
-        }
-        if(direction == 2 && side == Side.WEST) {
-            return true;
-        }
-        return direction == 1 && side == Side.EAST;
+        return false;
     }
 
     @Override
@@ -335,26 +362,33 @@ public class ButtonBlock extends Block
         {
             return;
         }
-        int l = world.getBlockMetadata(x, y, z);
-        if((l & 8) == 0)
+        int meta = world.getBlockMetadata(x, y, z);
+        if((meta & MASK_POWERED) == 0)
         {
             return;
         }
-        world.setBlockMetadataWithNotify(x, y, z, l & 7);
+        world.setBlockMetadataWithNotify(x, y, z, meta & ~MASK_POWERED);
         world.notifyBlocksOfNeighborChange(x, y, z, id);
-        int i1 = l & 7;
-        if(i1 == 1) {
-            world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
-        } else if(i1 == 2) {
-            world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
-        } else if(i1 == 3) {
-            world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
-        } else if(i1 == 4) {
-            world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
-        } else if(i1 == 5) {
-            world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
-        } else {
-            world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+        int direction = meta & MASK_DIRECTION;
+        switch (direction) {
+            case SIDE_WEST:
+                world.notifyBlocksOfNeighborChange(x - 1, y, z, id);
+                break;
+            case SIDE_EAST:
+                world.notifyBlocksOfNeighborChange(x + 1, y, z, id);
+                break;
+            case SIDE_NORTH:
+                world.notifyBlocksOfNeighborChange(x, y, z - 1, id);
+                break;
+            case SIDE_SOUTH:
+                world.notifyBlocksOfNeighborChange(x, y, z + 1, id);
+                break;
+            case SIDE_TOP:
+                world.notifyBlocksOfNeighborChange(x, y + 1, z, id);
+                break;
+            case SIDE_BOTTOM:
+                world.notifyBlocksOfNeighborChange(x, y - 1, z, id);
+                break;
         }
 
         world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) x + 0.5D, (double) y + 0.5D, (double) z + 0.5D, "random.click", 0.3F, 0.5F);
diff --git a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java b/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
index 0f231c41a..6917f4f25 100644
--- a/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
+++ b/src/main/java/net/minecraft/core/block/CacaoLeavesBlock.java
@@ -9,6 +9,7 @@ import net.minecraft.core.item.IBonemealable;
 import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
@@ -19,6 +20,8 @@ import java.util.Random;
 
 public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
 
+    public static final int MASK_GROWTH_DATA = 0b1111_0000;
+    public static final int MAX_GROWTH_STATE = 4;
     static final int BEAN_GROWTH_RATE = 50;
     public CacaoLeavesBlock(String key, String namespaceId, int id) {
         super(key, namespaceId, id, Material.leaves);
@@ -39,12 +42,12 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
     {
-        int growthRate = (meta & 0xF0) >> 4;
         if (dropCause == EnumDropCause.PICK_BLOCK || dropCause == EnumDropCause.SILK_TOUCH) return new ItemStack[] { new ItemStack(this) };
 
+        int growthRate = getGrowthRate(meta);
         if (growthRate > 1)
         {
-            return new ItemStack[] { new ItemStack(Items.DYE, MathHelper.floor((double) growthRate / 2), 3)};
+            return new ItemStack[] { new ItemStack(Items.DYE, MathHelper.ceil((double) growthRate / 2), DyeColor.BROWN.itemMeta)};
         }
 
         return super.getBreakResult(world, dropCause, meta, blockEntity);
@@ -63,16 +66,17 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
 
     public boolean harvest(World world, int x, int y, int z, @Nullable Player player) {
         int meta = world.getBlockMetadata(x, y, z);
-        int decayData = meta & 0x0F;
-        int growthRate = (meta & 0xF0) >> 4;
-        if((growthRate) > 0)
+        int growthRate = getGrowthRate(meta);
+        if(growthRate > 0)
         {
-            world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
+            if (player != null) {
+                world.playSoundAtEntity(player, player, "random.pop", 0.2F, 0.5f);
+            }
             if(!world.isClientSide)
             {
                 dropBlockWithCause(world, EnumDropCause.WORLD, x, y, z, meta, null, null);
             }
-            world.setBlockMetadataWithNotify(x, y, z, decayData);
+            world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, 0));
             world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id, tickDelay());
             return true;
         }
@@ -88,18 +92,18 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
     public void updateTick(World world, int x, int y, int z, Random rand) {
         super.updateTick(world, x, y, z, rand);
         int meta = world.getBlockMetadata(x, y, z);
-        int growthRate = (meta & 0XF0) >> 4;
+        int growthRate = getGrowthRate(meta);
         if (rand.nextInt(BEAN_GROWTH_RATE) == 0) {
             if (world.getSeasonManager().getCurrentSeason() == Seasons.OVERWORLD_SUMMER) {
                 if (canBeansGrow(world, x, y, z)) {
-                    if ((growthRate) < 4) {
-                        world.setBlockMetadataWithNotify(x, y, z, (++growthRate) << 4 | meta);
+                    if (growthRate < MAX_GROWTH_STATE) {
+                        world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, ++growthRate));
                         world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id, tickDelay());
                     }
                 }
             }
             else if(growthRate > 0){
-                world.setBlockMetadataWithNotify(x, y, z, meta & 0X0F);
+                world.setBlockMetadataWithNotify(x, y, z, setGrowthRate(meta, 0));
                 world.scheduleBlockUpdate(x, y, z, Blocks.LEAVES_CACAO.id, tickDelay());
             }
         }
@@ -113,13 +117,13 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
     @Override
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
         int meta = world.getBlockMetadata(blockX, blockY, blockZ);
-        if(((meta & 0xF0) >> 4) < 4)
+        if(getGrowthRate(meta) < MAX_GROWTH_STATE)
         {
             if(!world.isClientSide)
             {
                 if(world.getSeasonManager().getCurrentSeason() != Seasons.OVERWORLD_SUMMER)
                     return true;
-                world.setBlockMetadataWithNotify(blockX, blockY, blockZ, (4 << 4) | meta);
+                world.setBlockMetadataWithNotify(blockX, blockY, blockZ, setGrowthRate(meta, MAX_GROWTH_STATE));
                 if (player == null || player.getGamemode().consumeBlocks())
                 {
                     itemstack.stackSize--;
@@ -129,4 +133,12 @@ public class CacaoLeavesBlock extends BaseLeavesBlock implements IBonemealable {
         }
         return false;
     }
+
+    public static int getGrowthRate(int meta) {
+        return (meta & MASK_GROWTH_DATA) >> 4;
+    }
+
+    public static int setGrowthRate(int meta, int growthRate) {
+        return (meta & ~MASK_GROWTH_DATA) | (growthRate << 4) & MASK_GROWTH_DATA;
+    }
 }
diff --git a/src/main/java/net/minecraft/core/block/ChestBlock.java b/src/main/java/net/minecraft/core/block/ChestBlock.java
index 9c866fa9e..62dcfcfe2 100644
--- a/src/main/java/net/minecraft/core/block/ChestBlock.java
+++ b/src/main/java/net/minecraft/core/block/ChestBlock.java
@@ -22,10 +22,10 @@ public class ChestBlock extends EntityBlock implements IPaintable {
 	}
 	
 	@Override
-	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side placeSide, Mob mob, double sideHeight) {
+	public void onBlockPlacedByMob(World world, int x, int y, int z, @NotNull Side placeSide, Mob mob, double xPlaced, double yPlaced) {
 		Direction direction = mob.getHorizontalPlacementDirection(placeSide).getOpposite();
 		Type type = Type.SINGLE;
-		
+
 		if(mob.isSneaking() && placeSide.isHorizontal() && (mob.rotationLockHorizontal == null || mob.rotationLockHorizontal == Direction.NONE)) {
 			int placedOnX = x;
 			int placedOnZ = z;
@@ -33,7 +33,7 @@ public class ChestBlock extends EntityBlock implements IPaintable {
 			if(placeSide == Side.SOUTH) placedOnZ--;
 			if(placeSide == Side.EAST) placedOnX--;
 			if(placeSide == Side.WEST) placedOnX++;
-			
+
 			if(isSingleChest(world, placedOnX, y, placedOnZ)) {
 				Direction direction2 = getDirectionFromMeta(world.getBlockMetadata(placedOnX, y, placedOnZ));
 				if(direction2 == Direction.NORTH) {
@@ -127,14 +127,67 @@ public class ChestBlock extends EntityBlock implements IPaintable {
 				}
 			}
 		}
-		
+
 		int meta = world.getBlockMetadata(x, y, z);
 		meta = getMetaWithDirection(meta, direction);
 		meta = getMetaWithType(meta, type);
-		
+
 		world.setBlockMetadata(x, y, z, meta);
 	}
-	
+
+	@Override
+	public void onBlockPlacedOnSide(World world, int x, int y, int z, @NotNull Side side, double xPlaced, double yPlaced) {
+		Direction direction = side.getOpposite().getDirection();
+		Type type = Type.SINGLE;
+
+        if (direction == Direction.NORTH) {
+            if (isSingleChestWithDirection(world, x - 1, y, z, direction) && !isSingleChestWithDirection(world, x + 1, y, z, direction)) {
+                type = Type.LEFT;
+                setType(world, x - 1, y, z, Type.RIGHT);
+            }
+            if (isSingleChestWithDirection(world, x + 1, y, z, direction) && !isSingleChestWithDirection(world, x - 1, y, z, direction)) {
+                type = Type.RIGHT;
+                setType(world, x + 1, y, z, Type.LEFT);
+            }
+        }
+        if(direction == Direction.EAST) {
+            if(isSingleChestWithDirection(world, x, y, z - 1, direction) && !isSingleChestWithDirection(world, x, y, z + 1, direction)) {
+                type = Type.LEFT;
+                setType(world, x, y, z - 1, Type.RIGHT);
+            }
+            if(isSingleChestWithDirection(world, x, y, z + 1, direction) && !isSingleChestWithDirection(world, x, y, z - 1, direction)) {
+                type = Type.RIGHT;
+                setType(world, x, y, z + 1, Type.LEFT);
+            }
+        }
+        if(direction == Direction.SOUTH) {
+            if(isSingleChestWithDirection(world, x - 1, y, z, direction) && !isSingleChestWithDirection(world, x + 1, y, z, direction)) {
+                type = Type.RIGHT;
+                setType(world, x - 1, y, z, Type.LEFT);
+            }
+            if(isSingleChestWithDirection(world, x + 1, y, z, direction) && !isSingleChestWithDirection(world, x - 1, y, z, direction)) {
+                type = Type.LEFT;
+                setType(world, x + 1, y, z, Type.RIGHT);
+            }
+        }
+        if(direction == Direction.WEST) {
+            if(isSingleChestWithDirection(world, x, y, z - 1, direction) && !isSingleChestWithDirection(world, x, y, z + 1, direction)) {
+                type = Type.RIGHT;
+                setType(world, x, y, z - 1, Type.LEFT);
+            }
+            if(isSingleChestWithDirection(world, x, y, z + 1, direction) && !isSingleChestWithDirection(world, x, y, z - 1, direction)) {
+                type = Type.LEFT;
+                setType(world, x, y, z + 1, Type.RIGHT);
+            }
+        }
+
+        int meta = world.getBlockMetadata(x, y, z);
+		meta = getMetaWithDirection(meta, direction);
+		meta = getMetaWithType(meta, type);
+
+		world.setBlockMetadata(x, y, z, meta);
+	}
+
 	public void checkIfOtherHalfExists(World world, int x, int y, int z) {
 		int meta = world.getBlockMetadata(x, y, z);
 		Type type = getTypeFromMeta(meta);
diff --git a/src/main/java/net/minecraft/core/block/CropsWheatBlock.java b/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
index 2edf0870f..ee1167de8 100644
--- a/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
+++ b/src/main/java/net/minecraft/core/block/CropsWheatBlock.java
@@ -13,12 +13,10 @@ import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import org.jetbrains.annotations.Nullable;
 
-// Referenced classes of package net.minecraft.src:
-//            FlowerBlock, Block, World, ItemEntity,
-//            ItemStack, Item
-
 public class CropsWheatBlock extends FlowerBlock implements IBonemealable
 {
+    public static final int MASK_GROWTH = 0b0000_0111;
+    public static final int MAX_GROWTH_STATE = 7;
 	public CropsWheatBlock(String key, String namespaceId, int id)
     {
         super(key, namespaceId, id);
@@ -40,7 +38,7 @@ public class CropsWheatBlock extends FlowerBlock implements IBonemealable
         if(world.getBlockLightValue(x, y + 1, z) >= 9)
         {
             int l = world.getBlockMetadata(x, y, z);
-            if(l < 7)
+            if(l < MAX_GROWTH_STATE)
             {
                 float f = getGrowthRate(world, x, y, z);
                 if(rand.nextInt((int)(100F / f)) == 0)
@@ -52,9 +50,9 @@ public class CropsWheatBlock extends FlowerBlock implements IBonemealable
         }
     }
 
-    public void fertilize(World world, int i, int j, int k)
+    public void fertilize(World world, int x, int y, int z)
     {
-        world.setBlockMetadataWithNotify(i, j, k, 7);
+        world.setBlockMetadataWithNotify(x, y, z, MAX_GROWTH_STATE);
     }
 
     private float getGrowthRate(World world, int x, int y, int z)
@@ -124,7 +122,7 @@ public class CropsWheatBlock extends FlowerBlock implements IBonemealable
     @Override
     public ItemStack[] getBreakResult(World world, EnumDropCause dropCause, int meta, BlockEntity blockEntity)
     {
-        if (meta != 7)
+        if (meta != MAX_GROWTH_STATE)
         {
             return new ItemStack[] { new ItemStack(Items.SEEDS_WHEAT) };
         }
@@ -136,7 +134,7 @@ public class CropsWheatBlock extends FlowerBlock implements IBonemealable
 
     @Override
     public boolean onBonemealUsed(ItemStack itemstack, @Nullable Player player, World world, int blockX, int blockY, int blockZ, Side side, double xPlaced, double yPlaced) {
-        if(world.getBlockMetadata(blockX, blockY, blockZ) < 7)
+        if(world.getBlockMetadata(blockX, blockY, blockZ) < MAX_GROWTH_STATE)
         {
             if(!world.isClientSide)
             {
